# MAC Address Spoofing
MAC spoofing is a technique for changing a factory-assigned Media Access Control (MAC) address of a network interface on a networked device. The MAC address that is hard-coded on a network interface controller (NIC) cannot be changed. However, many drivers allow the MAC address to be changed. Additionally, there are tools which can make an operating system believe that the NIC has the MAC address of a user's choosing. The process of masking a MAC address is known as MAC spoofing. Essentially, MAC spoofing entails changing a computer's identity, for any reason, and it is relatively easy.

<p align="center">
  <img src="https://d5ngkkf53wl41.cloudfront.net/tutorials/ethical-hacking/mac-address-spoofing.png" />
</p>

### Why changing MAC address?
* Increase anonymity.
* Impersonate other devices.
* Bypass filters.

**note**: the lab will show how to change your MAC address only on the memory not physically.

### Objectives
* Change MAC address on **Kali Linux**.
* Change MAC address on **Windows**.

### Requisites
* Kali Linux virtual machine.
* Alfa network adapter, or other with similar chipset. [[+]](https://kennyvn.com/best-wireless-adapters-kali-linux/)
* Windows 7, 8 or 10 virtual machine.

## Using `macchanger` (Kali)
Macchanger is a tool that is included with any version of Kali Linux rolling edition and can change the MAC address to any desired address until the next reboot. In this lab we will be spoofing the MAC address of our wireless adapter with a random MAC address generated by **Macchanger on Kali Linux.**

Repo: https://github.com/alobbs/macchanger

0. Use `ifconfig` to see your current MAC address of your Network adapter:<br><br>
`ifconfig`

1. Turn off the Network adapter:<br><br>
`ifconfig wlan1 down`

2. Next, change your MAC address to a new random MAC Address using `macchanger`:<br><br>
`macchanger -r wlan1`

```
Current MAC:   f2:30:a0:1a:41:b3 (unknown)
Permanent MAC: 00:c1:c8:a1:e7:d1 (ALFA, INC.)
New MAC:       ce:11:9a:98:fe:ad (unknown)
```

## Changing MAC address manually (Kali)
0. Turn off the Network adapter:<br><br>
`ifconfig wlan0 down`

1. Change the address using `hw ether` option from **ifconfig** using any MAC address you want:<br><br>
`ifconfig wlan0 hw ether 00:11:22:33:44:55`

2. Enable the interface:<br><br>
`ifconfig wlan0 up`

3. Check the changes of the network adapter:<br><br>
`ifconfig`

***
## SMAC GUI Tool (Windows)
SMAC is a powerful and easy-to-use tool for MAC address changer (spoofer). The tool can activate a new MAC address right after changing it automatically.

https://smac.soft32.com/

![smac](https://thegeekpage.com/wp-content/uploads/2016/05/mac-address-changer-tool.gif)
