# CheatSheets

- Unix/Linux
  - [Linux cheat sheet](https://reconshell.com/linux-cheat-sheet/)
  - [All In One Linux Commands](https://reconshell.com/all-in-one-linux-commands/)
  - [Bash Cheat Sheet](https://reconshell.com/bash-cheat-sheet/)
  - [Linux commands and shell scripting notes](https://reconshell.com/linux-commands-and-shell-scripting-notes/)
  - [Community-sourced cheatsheets](https://github.com/cheat/cheatsheets)

---

Cheat Sheets
------------

[Reverse Shell Cheat Sheet](https://pentestmonkey.net/cheat-sheet/shells/reverse-shell-cheat-sheet "Permanent Link to Reverse Shell Cheat Sheet")
-------------------------------------------------------------------------------------------------------------------------------------------------

If you’re lucky enough to find a command execution vulnerability during a penetration test, pretty soon afterwards you’ll probably want an interactive shell. If it’s not possible to add a new account / SSH key / .rhosts file and just log in, your next step is likely to be either trowing back a reverse shell or binding \[…\]

[Shells](https://pentestmonkey.net/category/cheat-sheet/shells) [bash](https://pentestmonkey.net/tag/bash), [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [netcat](https://pentestmonkey.net/tag/netcat), [pentest](https://pentestmonkey.net/tag/pentest), [perl](https://pentestmonkey.net/tag/perl), [php](https://pentestmonkey.net/tag/php), [python](https://pentestmonkey.net/tag/python), [reverseshell](https://pentestmonkey.net/tag/reverseshell), [ruby](https://pentestmonkey.net/tag/ruby), [xterm](https://pentestmonkey.net/tag/xterm), Comments Off on Reverse Shell Cheat Sheet

[](https://pentestmonkey.net/cheat-sheet/shells/reverse-shell-cheat-sheet)

[SSH Cheat Sheet](https://pentestmonkey.net/cheat-sheet/ssh-cheat-sheet "Permanent Link to SSH Cheat Sheet")
------------------------------------------------------------------------------------------------------------

SSH has several features that are useful during pentesting and auditing.  This page aims to remind us of the syntax for the most useful features. NB: This page does not attempt to replace the man page for pentesters, only to supplement it with some pertinent examples. SOCKS Proxy Set up a SOCKS proxy on 127.0.0.1:1080 that lets \[…\]

[Cheat Sheets](https://pentestmonkey.net/category/cheat-sheet) [pentest](https://pentestmonkey.net/tag/pentest), [ssh](https://pentestmonkey.net/tag/ssh), Comments Off on SSH Cheat Sheet

[](https://pentestmonkey.net/cheat-sheet/ssh-cheat-sheet)

[John The Ripper Hash Formats](https://pentestmonkey.net/cheat-sheet/john-the-ripper-hash-formats "Permanent Link to John The Ripper Hash Formats")
---------------------------------------------------------------------------------------------------------------------------------------------------

John the Ripper is a favourite password cracking tool of many pentesters.  There is plenty of documentation about its command line options. I’ve encountered the following problems using John the Ripper.  These are not problems with the tool itself, but inherent problems with pentesting and password cracking in general. Sometimes I stumble across hashes on a \[…\]

[Cheat Sheets](https://pentestmonkey.net/category/cheat-sheet) [johntheripper](https://pentestmonkey.net/tag/johntheripper), [pentest](https://pentestmonkey.net/tag/pentest), Comments Off on John The Ripper Hash Formats

[](https://pentestmonkey.net/cheat-sheet/john-the-ripper-hash-formats)

[Informix SQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/informix-sql-injection-cheat-sheet "Permanent Link to Informix SQL Injection Cheat Sheet")
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Some useful syntax reminders for SQL Injection into Informix databases…

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [database](https://pentestmonkey.net/tag/database), [informix](https://pentestmonkey.net/tag/informix), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/informix-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/informix-sql-injection-cheat-sheet)

[MSSQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/mssql-sql-injection-cheat-sheet "Permanent Link to MSSQL Injection Cheat Sheet")
------------------------------------------------------------------------------------------------------------------------------------------------------------------

Some useful syntax reminders for SQL Injection into MSSQL databases…

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [mssql](https://pentestmonkey.net/tag/mssql), [sqlinjection](https://pentestmonkey.net/tag/sqlinjection), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/mssql-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/mssql-sql-injection-cheat-sheet)

[Oracle SQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/oracle-sql-injection-cheat-sheet "Permanent Link to Oracle SQL Injection Cheat Sheet")
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Some useful syntax reminders for SQL Injection into Oracle databases…

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [database](https://pentestmonkey.net/tag/database), [oracle](https://pentestmonkey.net/tag/oracle), [pentest](https://pentestmonkey.net/tag/pentest), [sqlinjection](https://pentestmonkey.net/tag/sqlinjection), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/oracle-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/oracle-sql-injection-cheat-sheet)

[MySQL SQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/mysql-sql-injection-cheat-sheet "Permanent Link to MySQL SQL Injection Cheat Sheet")
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Some useful syntax reminders for SQL Injection into MySQL databases…

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [database](https://pentestmonkey.net/tag/database), [mysql](https://pentestmonkey.net/tag/mysql), [pentest](https://pentestmonkey.net/tag/pentest), [sqlinjection](https://pentestmonkey.net/tag/sqlinjection), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/mysql-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/mysql-sql-injection-cheat-sheet)

[Postgres SQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/postgres-sql-injection-cheat-sheet "Permanent Link to Postgres SQL Injection Cheat Sheet")
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Some useful syntax reminders for SQL Injection into PostgreSQL databases…

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [database](https://pentestmonkey.net/tag/database), [pentest](https://pentestmonkey.net/tag/pentest), [postgresql](https://pentestmonkey.net/tag/postgresql), [sqlinjection](https://pentestmonkey.net/tag/sqlinjection), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/postgres-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/postgres-sql-injection-cheat-sheet)

[DB2 SQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/db2-sql-injection-cheat-sheet "Permanent Link to DB2 SQL Injection Cheat Sheet")
--------------------------------------------------------------------------------------------------------------------------------------------------------------------

Finding a SQL injection vulnerability in a web application backed by DB2 isn’t too common in my experience.  When you do find one, though it pays to be prepared…

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [database](https://pentestmonkey.net/tag/database), [db2](https://pentestmonkey.net/tag/db2), [pentest](https://pentestmonkey.net/tag/pentest), [sqlinjection](https://pentestmonkey.net/tag/sqlinjection), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/db2-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/db2-sql-injection-cheat-sheet)

[Ingres SQL Injection Cheat Sheet](https://pentestmonkey.net/cheat-sheet/sql-injection/ingres-sql-injection-cheat-sheet "Permanent Link to Ingres SQL Injection Cheat Sheet")
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Ingres seems to be one of the less common database backends for web applications, so I thought it would be worth installing it and making some notes to make my next Ingres-based web app test a little easier.

[SQL Injection](https://pentestmonkey.net/category/cheat-sheet/sql-injection) [cheatsheet](https://pentestmonkey.net/tag/cheatsheet), [database](https://pentestmonkey.net/tag/database), [ingres](https://pentestmonkey.net/tag/ingres), [pentest](https://pentestmonkey.net/tag/pentest), [sqlinjection](https://pentestmonkey.net/tag/sqlinjection), [0](https://pentestmonkey.net/cheat-sheet/sql-injection/ingres-sql-injection-cheat-sheet#respond)

[](https://pentestmonkey.net/cheat-sheet/sql-injection/ingres-sql-injection-cheat-sheet)


---

- [Rico's cheatsheets](https://devhints.io/)
